#!perl

#####################################################################
#IBM Confidential
#OCO Source Materials
#Rational ClearQuest
#(C) Copyright IBM Corp. 2006
#The source code for this program is not published or otherwise
#divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#####################################################################

# Perl script to run the cqdiagnostic tool.
#

# Section 1: Client Configuration -----------------------------------

# First, setup the path to IBM JRE and add it to path.
# Default values are based on the assumption that Clearquest is installed in C:\\Program Files\
$ibmjredir = "C:\\Program Files\\Rational\\Common\\java5.0\\jre\\bin";
$ENV{PATH} = "$ibmjredir;$ENV{PATH}";

# Then, set the CQ diagnostic home. The default location is
# C:\Program Files\Rational|ClearQuest\diagnostic.
$cqdiagnostichome = "C:\\Program Files\\Rational\\ClearQuest\\diagnostic";
# -------------------------------------------------------------------

# Section 2: Database server Configuration --------------------------

# Specify information for master database.
# The possible values for masterdbvendor are -
# MS_ACCESS, SQL_SERVER, ORACLE and DB2
$masterdbvendor = "MS_ACCESS";

# Specify physical server name.
# In case of MS_ACCESS, this will be file name like "c:\\dbs\\master.mdb"
$masterdbserver = "C:\\database\\master.mdb";

# Specify server port number.
# In case of MS_ACCESS, this can be blank.
$masterdbserverport = "";

# Specify database name.
# In case of MS_ACCESS, this will be be blank
$masterdbname = "";

# Specify database user name that is used by ClearQuest to connect to the database.
# In case of MS_ACCESS, this will be be blank
$masterdbuserid = "";

# Specify password used by the user account above.
# In case of MS_ACCESS, set this to ""
$masterdbpassword = "";

# Specify special connect options used by CQ database.
# In case of MS_ACCESS, set this to ""
$masterdbconnectoptions ="";


#Make this vaue "true" if you want to test user db also
$validateuserdb = "true";

# Specify information for user database.
# Specify the logical name of ClearQuest database like SAMPL.
$userdblogicalname = "SAMPL";

# The possible values for userdbvendor are -
# MS_ACCESS, SQL_SERVER, ORACLE and DB2
$userdbvendor = "MS_ACCESS";

# Specify physical server name.
# In case of MS_ACCESS, this will be file name like "c:\\dbs\\sample.mdb"
$userdbserver = "C:\\database\\user.mdb";

# Specify server port number.
# In case of MS_ACCESS, this can be blank.
$userdbserverport="";

# Specify database name.
# In case of MS_ACCESS, this will be be blank
$userdbname = "";

# Specify database user name that is used by ClearQuest to connect to the database.
# In case of MS_ACCESS, this will be be blank
$userdbuserid = "";

# Specify password used by the user account above.
# In case of MS_ACCESS, set this to ""
$userdbpassword = "";

# Specify special connect options used by CQ database.
# In case of MS_ACCESS, set this to ""
$userdbconnectoptions = "";

#Make this vaue "true" if you want to use only userdb
$validateuserdbonly = "false";

# ----------Section 3: Subcommand ------------------------------

# $subcommand  specifies subcommand to be used.
# "validatedb" will be used to validate the rules against databases
# This is the most common and usual subcommand you need to use.
# Other possible commands are - 
# "describe" to describe specific rules in details.
$subcommand = "validatedb";

# ----------------------------------------------------------------
#Fill in following section to execute certain rules only. 
#Please fill only one of rulegroup or rulename.
#Multiple values can be given using space as separator

# $rulegroup specifies rule groups that could be run.
# The possible values are
# "basic" to run minimum set of rule
# "performance" to run rules related to performance
# "users" to run rules about users and groups information
# "multisite" to run rules in multisite area
# If you leave it empty, all the rules will be executed.
$rulegroup = ""; 

# $rulename can be used to specify rules that could be run.
# There are a number of rules. 
# If you leave it empty, all the rules will be executed.
$rulename = "";  
# ----------------------------------------------------------------

# --------------Section 4: Other settings ------------------------
# Please mention appropriate location for cqdiagnostics log file
$logfile =  "C:\\Program Files\\Rational\\ClearQuest\\diagnostic\\dbi.log";
$resultsfile =  "C:\\Program Files\\Rational\\ClearQuest\\diagnostic\\dbi-results.txt";

# Set locale. Supported locales are English, japanese, chinese
$locale = "english";

# ---------------------------------------------------------------
# --------------Section 5: Misc configuration -------------------
# Usually you don't have to change this section.

# Set the path separation character. On Windows it is "\\" and on Unix it is "/"
# Set the classpath separation character. On Windows it is ";" and on Unix it is ":"
$OS=$ENV{"OS"};

#On Windows $OS will have some value
if ($OS ne "") {
	$pathSepChar = "\\";
	$cpSepChar = ";";
	$cqdiagnosticicu = "C:\\Program Files\\Rational\\common\\java\\icu";
}else
{
	$pathSepChar = "/";
	$cpSepChar = ":";
	$cqdiagnosticicu = "/opt/rational/common/jar";
}

$mainjar = "\"$cqdiagnostichome" . $pathSepChar . "cqdiagnostics.jar\"";
$rulefile = "$cqdiagnostichome" . $pathSepChar . "configuration" . $pathSepChar . "rules.xml";
$orgclasspath = $ENV{CLASSPATH};
$ddpath = "$cqdiagnostichome" . $pathSepChar . "lib" . $pathSepChar . "datadirect";
$classpath = "$cqdiagnostichome" . $pathSepChar . "configuration" . $cpSepChar;
$classpath .= "$cqdiagnostichome" . $pathSepChar . "cqdiagnostics.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "db2packagemanager.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKbase.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKdb2.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKoracle.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKresource.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKsqlserver.jar" . $cpSepChar;
$classpath .= $ddpath . $pathSepChar . "RKutil.jar" . $cpSepChar;
#$classpath .= "$cqdiagnostichome" . $pathSepChar . "lib" . $pathSepChar . "icu" . $pathSepChar . "icu4j.jar" . $cpSepChar;
$classpath .= "$cqdiagnosticicu" . $pathSepChar . "icu4j-3_8_1.jar" . $cpSepChar;
$classpath .= $orgclasspath;

$ENV{CLASSPATH} = $classpath;

if($masterdbserverport ne "")  {
	$masterdbserver .= ":".$masterdbserverport;
}

if($userdbserverport ne "")  {
	$userdbserver .= ":".$userdbserverport;
}
# -------------------------------------------------------------------

# The remaining task now is to compose and execute the command.
$cmd = "\"$ibmjredir" . $pathSepChar . "java\" ";


$cmd .= " -cp \"$classpath\" com.ibm.rational.diagnostics.dbintegrity.ui.cli.DbDiagnostics $subcommand -rulefile \"$rulefile\" ";	

if($subcommand eq "validatedb")
{
	$cmd .= " -logfile \"$logfile\" -resultsfile \"$resultsfile\" ";
}

if($subcommand eq "validatedb")
{
	#In case of MS Access, We just need to pass database name (essentially MS ACCESS file name)
	if($masterdbvendor ne "MS_ACCESS")
	{
		$cmd .= "-dbinfoschemarepo $masterdbvendor \"$masterdbserver\" \"$masterdbname\" \"$masterdbuserid\" \"$masterdbpassword\" \"$masterdbconnectoptions\" ";
		
		if ($validateuserdb eq "true") {
			$cmd .= "-dbinfouser $userdblogicalname $userdbvendor \"$userdbserver\" \"$userdbname\" \"$userdbuserid\" \"$userdbpassword\" \"$userdbconnectoptions\" ";
		}
	}else
	{
		$cmd .= "-dbinfoschemarepo $masterdbvendor \"$masterdbserver\" ";
	
		if ($validateuserdb eq "true") {
			$cmd .= "-dbinfouser $userdblogicalname $userdbvendor \"$userdbserver\" ";
		}
	}

	if($validateuserdbonly eq "true")
	{
		$cmd .= "-validateuserdbonly";
	}
}

#Check if we have passed any rule names of rule groups. Modifying the command appropriately
if($rulename ne "")
{
	$cmd .= " -rulenames $rulename";
}

if ($rulegroup ne "") 
{
	$cmd .= " -rulegroups $rulegroup";
}

$cmd .= " -locale $locale ";

print STDOUT "\n";
print STDOUT $cmd;
print STDOUT "\n";

$kstat = system($cmd);
if ($kstat) {
    print STDOUT "Non-zero status $kstat returned by $cmd\n";
}
exit $kstat;

